//{$WARNINGS OFF}
//=============================================================================
//  EBhE̊Kw̃c[\
//
//  TreeVeiwőIEBhE͂ޘg`悷@\t
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ܂Czz̍ہCȂ闝R낤Ƃɑ㉿߂邱Ƃ֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N0526 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows XP(SP3)    + Delphi XE Pro
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY and Halbow
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit WindowTreeUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls;

type
  TWindowTreeForm = class(TForm)
    TreeView1: TTreeView;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
  protected
    procedure WndProc(var Message: TMessage); override;
  private
    { Private 錾 }
    ScreenDC         : HDC;
    ScreenCanvas     : TCanvas;
    procedure EnumChildren(Node:TTreeNode);
  public
    { Public 錾 }
    hTargetWnd      : HWND;
    TargetClassName : String;
  end;

var
  WindowTreeForm: TWindowTreeForm;

implementation

{$R *.DFM}

uses WinSearch, DebugWndUnit;

//=============================================================================
//  tH[쐬
//  ݂̉EBhẼXg쐬
//  YtWinSearch.pas̊֐ނ𗘗p
//
//  ̃tH[̊e{^̃vpeB͈ȉ̒ʂ
//  [OK]     ModalResult := mrOK;
//           Default := True;
//  [Cancel] ModalResult := mrCancel;
//           Cancel := True;
//=============================================================================
procedure TWindowTreeForm.FormCreate(Sender: TObject);
var
  WA       : THWndArray;
  i        : Integer;
  Num      : Integer;
  StrItem  : String;
  StrClass : String;
  StrText  : String;
  Node     : TTreeNode;
begin
  //EBhE͂ދ``pɁCXN[̃foCXReLX擾
  //}`j^[ւ̍l͂Ȃ
  ScreenDC            :=  CreateDC('DISPLAY', nil, nil, nil);
  ScreenCanvas        := TCanvas.Create;
  ScreenCanvas.Handle := ScreenDC;

  Num := WinSearch.EnumVisbleNoOwnedWindows(WA);

  if Num > 0 then begin
    for i := 1 to Num do begin
      //Av͏O
      if (WA[i] <> Application.Handle) and
         (WA[i] <> Application.MainForm.Handle) then begin
        StrClass := WinSearch.GetClassNameStr(WA[i]);
        StrText  := WinSearch.GetWindowTextStr(WA[i]);
        StrItem  := Format('%s ...... %s', [StrClass, StrText]);

        //m[hȉ̃EBhE
        Node := TreeView1.Items.AddObject(nil, StrItem, Pointer(WA[i]));
        EnumChildren(Node);
      end;
    end;
  end;

  TreeView1.TopItem.Expand(False);
end;

//=============================================================================
//  tH[鎞
//  CtH[(ĂяõtH[)ɈnϐɒlZbg
//
//  hTargetWnd      : Ώۂ̃EBhẼnh
//  TargetClassName : Ώۂ̃EBhẼNX
//=============================================================================
procedure TWindowTreeForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //XN[̃foCXReLX֌W̉
  InvalidateRect(0, nil, True);
  ScreenCanvas.Free;
  DeleteDC(ScreenDC);

  if ModalResult = mrOk then begin
    if TreeView1.Selected <> nil then begin
      hTargetWnd      := HWND(TreeView1.Selected.Data);
      TargetClassName := WinSearch.GetClassNameStr(hTargetWnd);
    end;
  end else begin
    hTargetWnd := 0;
  end;
end;

//=============================================================================
//  ̃m[hɑEBhȆSĂ̎qEBhEWJ
//
//  ł́C̃EBhE̓c[ɒǉȂ悤ɂĂ
//=============================================================================
procedure TWindowTreeForm.EnumChildren(Node: TTreeNode);
var
  WA      : THWndArray;
  i       : Integer;
  Num     : Integer;
  TN      : TTreeNode;
  StrItem : String;
begin
  if Node.Count > 0 then exit;

  Num := WinSearch.EnumDirectChildren(WA, HWND(Node.Data));
  if Num > 0 then begin
    for i := 1 to Num do begin
      if IsWindowVisible(WA[i]) then begin
        StrItem := WinSearch.GetClassNameStr(WA[i]);
        TN      := TreeView1.Items.AddChildObject(Node, StrItem, Pointer(WA[i]));
        EnumChildren(TN);
      end;
    end;
  end;

  Num := WinSearch.EnumDirectOwnedWindows(WA, HWND(Node.Data));
  if Num > 0 then begin
    for i := 1 to Num do begin
      if IsWindowVisible(WA[i]) then begin
        StrItem := '*' + WinSearch.GetClassNameStr(WA[i]);
        TN      := TreeView1.Items.AddChildObject(Node, StrItem, Pointer(WA[i]));
        EnumChildren(TN);
      end;
    end;
  end;
end;

//=============================================================================
//  c[r[̃m[hNbNqEBhE
//  xWJƁCc[ĂȌ̂܂
//  Vɂɂ́Cēx̃tH[J
//=============================================================================
procedure TWindowTreeForm.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
  if (Node.Level = 0) and (Node.Count = 0) then begin
    EnumChildren(Node);
    Node.Expand(True);
  end;

  //fXNgbv̍ĕ`
  InvalidateRect(0, nil, True);

  if Node <> nil then begin
    if Timer1.Enabled = False then begin
      Timer1.Interval := 200;
      Timer1.Enabled  := True;
    end;
  end;
end;

//=============================================================================
//  Timer1OnTimerCxg
//  TreeView̑INodeɊYEBhE͂ޘg\
//=============================================================================
procedure TWindowTreeForm.Timer1Timer(Sender: TObject);
var
  RectWnd    : TRect;
  LineWidth  : Integer;
  LineColor  : TColor;
  ANode      : TTreeNode;
begin
  ANode := TreeView1.Selected;
  if ANode = nil then exit;

  //Ώۂ̃EBhE\̎͘g\Ȃ
  if IsWindowVisible(HWND(ANode.Data)) then begin

    //TCYƈʒu擾
    GetWindowRect(HWND(ANode.Data), RectWnd);

    LineWidth := 4;
    LineColor := clRed;

    //g`
    with ScreenCanvas do begin
      Pen.Color := LineColor;
      Pen.Width := LineWidth;

      MoveTo (RectWnd.Left,  RectWnd.Top);
      LineTo (RectWnd.Right, RectWnd.Top);
      LineTo (RectWnd.Right, RectWnd.Bottom);
      LineTo (RectWnd.Left,  RectWnd.Bottom);
      LineTo (RectWnd.Left,  RectWnd.Top);
    end;
    Sleep(1);
  end;
end;

//=============================================================================
//  ̃tH[ړTCYC͋``𒆎~
//  ~ȂƁCXN[̋``悳ꂽ܂܂̈ړƂĂ܂1
//  ̃AvړCTCYœľۂ
//  ̏ꍇ́C̃tH[ړ
//=============================================================================
procedure TWindowTreeForm.WndProc(var Message: TMessage);
begin
  inherited;

  if Visible then begin
    if Message.Msg = WM_ENTERSIZEMOVE then begin
      if Timer1.Enabled then begin
        InvalidateRect(0, nil, True);
        Timer1.Enabled := False;
      end;
    end else
    if Message.Msg = WM_EXITSIZEMOVE then begin
      Timer1.Enabled := True;
    end;
  end;
end;

end.
